"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.amplicodeGetAnswers = void 0;
const base64_1 = require("../../util/base64");
const amplicodeGetAnswers = (options, gen, questions) => __awaiter(void 0, void 0, void 0, function* () {
    if (questions == null || questions.length === 0) {
        return {};
    }
    if (options.answers != null) {
        return yield getAnswersFromOptions(options.answers, gen);
    }
    return yield getAnswersFromPrompt(options, gen, questions);
});
exports.amplicodeGetAnswers = amplicodeGetAnswers;
function getAnswersFromOptions(answers, gen) {
    return __awaiter(this, void 0, void 0, function* () {
        gen.log('Skipping prompts since answers are provided');
        return base64_1.parseBase64Object(answers);
    });
}
function getAnswersFromPrompt(_options, _gen, _questions) {
    return __awaiter(this, void 0, void 0, function* () {
        throw new Error('Not supported');
    });
}
//# sourceMappingURL=amplicodeGetAnswers.js.map