"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const getTopAttributesFromQuery_1 = require("./getTopAttributesFromQuery");
const QUERY_STRING = `
{
  date 
  lines {
    quantity
  }
  amount
  customer {
     name
     email
  }
}
`;
const TOP_LEVEL_ATTRIBUTES = ['date', 'lines', 'amount', 'customer'];
describe('getAttributesFromQuery', () => {
    it('should correctly parse attributes', () => {
        const attributes = getTopAttributesFromQuery_1.getTopAttributesFromQuery(QUERY_STRING);
        chai_1.expect(attributes).to.have.same.members(TOP_LEVEL_ATTRIBUTES);
    });
});
//# sourceMappingURL=getTopAttributesFromQuery.test.js.map