"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addAddonPalette = void 0;
const jscodeshift_1 = __importStar(require("jscodeshift"));
const path_1 = __importDefault(require("path"));
function addAddonPalette(gen, dirShift, paletteComponentName, addonPackageName) {
    const destRoot = gen.destinationRoot();
    const srcDir = path_1.default.join(destRoot, dirShift ? dirShift : '');
    const appPalettePath = path_1.default.join(srcDir, 'dev', 'palette.tsx');
    if (!gen.fs.exists(appPalettePath)) {
        gen.log(`Unable to add addon's palette to app palette: app palette not found`);
        return;
    }
    const appPaletteContents = gen.fs.read(appPalettePath);
    const updatedAppPaletteContentns = injectAddonPalette(appPaletteContents, addonPackageName, paletteComponentName);
    gen.fs.write(appPalettePath, updatedAppPaletteContentns);
}
exports.addAddonPalette = addAddonPalette;
function injectAddonPalette(appPaletteContents, addonPackageName, paletteComponentName) {
    const tsxParser = jscodeshift_1.default.withParser('tsx');
    const paletteAst = tsxParser(appPaletteContents);
    if (isPaletteAlreadyImported(paletteAst, paletteComponentName)) {
        return appPaletteContents;
    }
    injectPaletteImport(paletteAst, paletteComponentName, addonPackageName);
    injectPaletteComponent(paletteAst, paletteComponentName);
    return paletteAst.toSource();
}
function createAddonPaletteJSX(paletteComponentName) {
    return `<${paletteComponentName}/>`;
}
function isPaletteAlreadyImported(ast, paletteComponentName) {
    return ast.find(jscodeshift_1.ImportDeclaration)
        .find(jscodeshift_1.ImportSpecifier)
        .filter(path => path.node.imported.name === paletteComponentName)
        .length > 0;
}
function injectPaletteImport(ast, paletteComponentName, addonPackageName) {
    const addonPaletteImport = jscodeshift_1.importDeclaration([jscodeshift_1.importSpecifier(jscodeshift_1.identifier(paletteComponentName))], jscodeshift_1.stringLiteral(`${addonPackageName}/palette`));
    ast.get().node.program.body.unshift(addonPaletteImport);
}
function injectPaletteComponent(ast, paletteComponentName) {
    const paletteAddonJSX = createAddonPaletteJSX(paletteComponentName);
    const palette = ast.findJSXElements('Palette');
    const [{ value: { children } }] = palette.paths();
    children === null || children === void 0 ? void 0 : children.push(jscodeshift_1.stringLiteral(paletteAddonJSX));
}
//# sourceMappingURL=addAddonPalette.js.map