"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const addMvpAppMenu_1 = require("./addMvpAppMenu");
const chai_1 = require("chai");
describe('transformAddScreenItem', () => {
    it('adds a screen item successfully', () => {
        const result = addMvpAppMenu_1.transformAddScreenItem(INPUT, 'pet-list', 'PetList');
        chai_1.expect(result.includes(NEW_KEY_VALUE_PAIR)).to.be.true;
    });
});
describe('transformAddScreenImport', () => {
    it('adds an import successfully', () => {
        const result = addMvpAppMenu_1.transformAddScreenImport(INPUT, 'PetList', './pet-list/');
        chai_1.expect(result.includes('import { PetList } from "./pet-list/PetList";'));
    });
});
const INPUT = `
import { Home } from "./home/Home";
import { ReactComponent } from "../framework/screen-api/ReactComponent";

export interface ScreenInfo {
  /**
   * i18n key for menu item / tab caption
   */
  captionKey: string;
  /**
   * Component that will be rendered in a new tab when menu item is clicked
   */
  component: ReactComponent;
  props?: any;
}

export const screenRegistry: Record<string, ScreenInfo> = {
  home: {
    component: Home,
    captionKey: "screen.home"
  }
  // TODO: delete me
  // 'owner-list': {
  //   component: OwnerList,
  //   captionKey: 'screen.OwnerList',
  // },
};

export function getScreenPaths(): string[] {
  return Object.keys(screenRegistry).map(k => "/" + k);
}
`;
const NEW_KEY_VALUE_PAIR = '"pet-list": "{\\n    componentName: PetList,\\n    captionKey: \'Pet List\'    \\n  }"';
//# sourceMappingURL=addMvpAppMenu.test.js.map