import Generator from "yeoman-generator";
import { JSXElement, Collection } from 'jscodeshift';
interface AddToMenuOpts {
    destRoot: string;
    dirShift: string | undefined;
}
interface ComponentInfo {
    componentFileName: string;
    componentClassName: string;
    menuLink: string;
    pathPattern: string;
    caption: string;
}
export interface AppMenuItemInfo {
    componentClassName: string;
    menuNode: string | null;
}
export declare function addToMenu(fs: Generator.MemFsEditor, { destRoot, dirShift, caption, menuLink, pathPattern, componentFileName, componentClassName }: AddToMenuOpts & ComponentInfo, addRouteCallback?: (routingContents: string, routeInfo: RouteInfo, customComponentParams?: {
    [param: string]: unknown;
}) => string, customComponentParams?: {
    [param: string]: unknown;
}): boolean;
export declare function addToAppMenu(fs: Generator.MemFsEditor, { destRoot, dirShift, menuNode, componentClassName }: AddToMenuOpts & AppMenuItemInfo, addAppMenuCallback?: (appMenuContents: string, appMenuItemInfo: AppMenuItemInfo, customComponentParams?: {
    [param: string]: unknown;
}) => string, customComponentParams?: {
    [param: string]: unknown;
}): boolean;
export declare type RouteInfo = ComponentInfo & {
    componentPath: string;
    pathPattern: string;
};
export declare const addRoute: (routingContents: string, { caption, pathPattern, menuLink, componentClassName, componentPath }: RouteInfo) => string;
export declare const addAppMenuItem: (appMenuContents: string, { componentClassName, menuNode }: AppMenuItemInfo) => string;
export declare function updateAppMenuContent(appMenuContents: string, componentClassName: string, menuNode: string | null, key: string): string;
export declare function getNewMenuItem(componentClassName: string, key: string): string;
export declare function pushStringNodeToParentChildren(parrent: Collection<JSXElement>, stringNode: string): string;
export declare function getUpdatedMenuWithRootNode(appMenuAST: Collection<any>, newMenuItem: string): string;
export declare function getUpdatedMenuWithCustomNode(appMenuAST: Collection<any>, menuNode: string, newMenuItem: string): string;
export {};
