"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.index = exports.icon = exports.description = exports.params = exports.options = exports.generator = exports.MvpEntityEditor = void 0;
const YeomanGenerator_1 = require("../../../building-blocks/YeomanGenerator");
const amplicodePipeline_1 = require("../../../building-blocks/pipelines/amplicodePipeline");
const path_1 = __importDefault(require("path"));
const answers_1 = require("./answers");
Object.defineProperty(exports, "params", { enumerable: true, get: function () { return answers_1.entityDetailsQuestions; } });
const template_model_1 = require("./template-model");
const amplicode_1 = require("../../../building-blocks/stages/options/pieces/amplicode");
Object.defineProperty(exports, "options", { enumerable: true, get: function () { return amplicode_1.amplicodeComponentOptionsConfig; } });
const write_1 = require("./write");
class MvpEntityEditor extends YeomanGenerator_1.YeomanGenerator {
    constructor(args, options) {
        super(args, options);
    }
    generate() {
        return __awaiter(this, void 0, void 0, function* () {
            yield amplicodePipeline_1.amplicodePipeline({
                templateDir: path_1.default.join(__dirname, 'template'),
                questions: answers_1.entityDetailsQuestions,
                stages: {
                    deriveTemplateModel: template_model_1.deriveEntityDetailsTemplateModel,
                    write: write_1.writeEntityDetails
                }
            }, this);
        });
    }
}
exports.MvpEntityEditor = MvpEntityEditor;
exports.generator = MvpEntityEditor;
const description = 'Standard entity editor screen with a form and action buttons.';
exports.description = description;
const icon = 'entity-details.svg';
exports.icon = icon;
const index = 20;
exports.index = index;
//# sourceMappingURL=index.js.map