"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveManagementTemplateModel = void 0;
const template_model_1 = require("../entity-details/template-model");
const amplicode_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/amplicode");
const graphql_tag_1 = __importDefault(require("graphql-tag"));
const BaseTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/BaseTemplateModel");
const util_1 = require("../../../building-blocks/stages/template-model/pieces/util");
const ScreenTemplateModel_1 = require("../../../building-blocks/stages/template-model/pieces/amplicode/ScreenTemplateModel");
const deriveManagementTemplateModel = (options, answers, schema) => __awaiter(void 0, void 0, void 0, function* () {
    const { listComponentName, detailsComponentName, listQuery, detailsQuery, upsertMutation, deleteMutation, shouldAddToMenu, mode = 'edit', idField = 'id', } = answers;
    const queryNode = graphql_tag_1.default(listQuery);
    const mutationNode = deleteMutation != null ? graphql_tag_1.default(deleteMutation) : undefined;
    const queryName = amplicode_1.getOperationName(queryNode);
    const deleteMutationName = mutationNode != null ? amplicode_1.getOperationName(mutationNode) : undefined;
    const entityDetailsTemplateModel = yield template_model_1.deriveEntityDetailsTemplateModel(options, {
        componentName: detailsComponentName,
        query: detailsQuery,
        mutation: upsertMutation,
        shouldAddToMenu: false,
        listQueryName: queryName,
    }, schema);
    return Object.assign(Object.assign(Object.assign(Object.assign({}, BaseTemplateModel_1.baseTemplateModel), util_1.templateUtilities), ScreenTemplateModel_1.deriveScreenTemplateModel(options, { componentName: listComponentName, shouldAddToMenu })), { listComponentName,
        detailsComponentName, queryString: listQuery, queryName, deleteMutationString: deleteMutation, deleteMutationName,
        mode,
        idField,
        shouldAddToMenu,
        entityDetailsTemplateModel });
});
exports.deriveManagementTemplateModel = deriveManagementTemplateModel;
//# sourceMappingURL=template-model.js.map