"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const questions_1 = require("../../common/questions");
const mpg_projectModel_json_1 = __importDefault(require("../fixtures/mpg-projectModel.json"));
const chai_1 = require("chai");
describe('interactive CLI question helpers', () => {
    it('correctly creates choices for an Entity', () => {
        const prop = {
            code: 'test',
            caption: 'test',
            propertyType: "ENTITY" /* ENTITY */,
        };
        // @ts-ignore TODO VP Replace enums with string union types in ProjectModel https://github.com/cuba-platform/front-generator/issues/46
        const question = questions_1.fromStudioProperty(prop, mpg_projectModel_json_1.default);
        chai_1.expect(question.choices).to.exist;
        chai_1.expect(question.choices).to.be.an('Array');
        const expectedEntityNames = [
            "scr_Car",
            "scr_CarDto",
            "scr_CarRent",
            "scr_FavoriteCar",
            "scr_Garage",
            "ScrUserInfo",
            "scr_SparePart",
            "scr_TechnicalCertificate",
            "scr_User",
            "scr_Customer",
            "scr_Order",
            "scr_OrderLine",
            "scr_Product",
            "scr_AssociationM2MTestEntity",
            "scr_AssociationM2OTestEntity",
            "scr_AssociationO2MTestEntity",
            "scr_AssociationO2OTestEntity",
            "scr_BoringStringIdTestEntity",
            "scr_CompositionO2MTestEntity",
            "scr_CompositionO2OTestEntity",
            "scr_DatatypesTestEntity",
            "scr_DatatypesTestEntity2",
            "scr_DatatypesTestEntity3",
            "scr_DeeplyNestedO2MTestEntity",
            "scr_DeeplyNestedTestEntity",
            "scr_IntIdentityIdTestEntity",
            "scr_IntegerIdTestEntity",
            "scr_StringIdTestEntity",
            "scr_WeirdStringIdTestEntity",
            "scr_TrickyIdTestEntity",
            "scr_Order_1",
        ];
        const actualEntityNames = question.choices.map((choice) => choice.name);
        chai_1.expect(actualEntityNames).to.deep.equal(expectedEntityNames);
    });
});
//# sourceMappingURL=questions.test.js.map