"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.expectRejectedPromise = void 0;
const chai_1 = require("chai");
function expectRejectedPromise(promiseCallback, errorMessage) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield promiseCallback();
            chai_1.expect.fail('The promise is fulfilled');
        }
        catch (err) {
            if (errorMessage != null) {
                chai_1.expect(err.message).to.equal(errorMessage);
            }
            return;
        }
    });
}
exports.expectRejectedPromise = expectRejectedPromise;
//# sourceMappingURL=test-utils.js.map