"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const relations_1 = require("../../../../building-blocks/stages/template-model/pieces/relations");
const projectModel = require('../../../fixtures/mpg-projectModel.json');
describe('entity management generation test', function () {
    it('should collect relations', function () {
        const attributes = [createAttr('attr1'), createAttr('attr2')];
        const relations = relations_1.getRelations(projectModel, attributes);
        chai_1.expect(relations.associations.attr1.path).eq('jmix/entities/scr_Car');
        chai_1.expect(relations.associations.attr2.path).eq('jmix/entities/scr_Car');
    });
    it('should sort out identical items from relation imports', function () {
        const relations = {
            e1: { className: 'Car', path: 'jmix/entities/mpg$Car' },
            e2: { className: 'Car', path: 'jmix/entities/mpg$Car' }
        };
        const entity = { className: 'Car', path: 'jmix/entities/mpg$Car' };
        const relationImports = relations_1.getRelationImports(relations, entity);
        chai_1.expect(relationImports.length).eq(1);
        chai_1.expect(relationImports[0].className).eq('Car');
        chai_1.expect(relationImports[0].path).eq('jmix/entities/mpg$Car');
    });
});
function createAttr(name) {
    return {
        mappingType: 'ASSOCIATION',
        name,
        type: {
            packageName: "com.company.scr.entity",
            className: "Car",
            fqn: "com.company.scr.entity.Car",
            label: "Car",
            entityName: "scr_Car"
        }
    };
}
//# sourceMappingURL=index.test.js.map